//
//  main.c
//  listeD
//
//  Created by soldano on 17/09/2014.
//  Copyright (c) 2014 soldano. All rights reserved.
//

#include <stdio.h>
#include "listesDoublementChainees.h"
void inverserListeD(listeD *pl);
listeD inverserListeND(listeD l);
listeD inverserListeNDPrim (listeD l);

int main(int argc, const char * argv[])
{
    listeD l,li;
    int i,n,x;
    //
    l=creerListe();
    scanf("%d",&n);
    for (i=0; i<n; i++) {
        scanf("%d",&x);
        l=ajouterEnPosition(x, HORS_LISTE, l);// en queue de l
    }
    afficherListe(l); //1
    inverserListeD(&l);    afficherListe(l); //2
    li=inverserListeND(l);  afficherListe(li);  //3
    viderListePrim(&li);
    li=inverserListeNDPrim(l);afficherListe(li);//4
    return 0;
}
/* fonctions */



void inverserListeD(listeD *pl){
    /* inverse la liste d'adresse pl (une adresse d'adresse donc) */
    // l'ide'e est de garder les m^emes cellules en inversant le chai^nage et
    //l'adresse du premier element
    listeD l,li;
    cellule *p, *paux, *pNext;
    //
    l=(*pl);
    if (l==NULL) {// rien a faire
        return ;
    }
    p=l;
    li=l->prec; // le premier de la liste inverse'e est dans la cellule pre'ce'dant la premi`ere
    // on parcourt ci dessous la liste par les liens prec en e'changeant le sens "suiv/prec"
    do{
        pNext=p->prec; // on me'morise l'adresse de la cellule a `traiter au prochain tour
        paux=p->suiv; // on inverse les sens "suiv/prec"
        p->suiv=p->prec;
        p->prec=paux;
        p=pNext; // on passe a l'element a `traiter au prochain tour
    }
    while (p!=l);// on sort si on a traite' tous les elements
    (*pl)=li;
    return;
    //
}

listeD inverserListeND(listeD l){
    /* renvoie une liste li inverse de la liste l (sans detruire l) */
    // l'ide'e est de parcourir la liste l (en partant du dernier) et à construire li en progressant dans l
    // par les liens prec
    listeD li;
    cellule *p, *pi,*pp,*ppi;
    //
    
    if (l==NULL) {// rien a faire
        return NULL ;
    }
    p=l->prec; // p pointe sur le dernier element de l (qui peut-être le premier)
    pi=(cellule*) malloc(sizeof(cellule)); // pi pointe sur le premier element a mettre dans li
    pi->valeur=p->valeur;
    li=pi;// li pointe sur cet element
    // on parcourt ci dessous la liste par les liens prec en dupliquant les elements
    // et en  chainant les duplicats dans l'ordre suiv
    while(p!=l){//
        pp=p; // on me'morise l'adresse de la cellule traitee au tour precedent
        ppi=pi; // et son duplicat dans li
        p=p->prec;// on avance dans la liste
        pi=(cellule*) malloc(sizeof(cellule)); // et on duplique un element
        pi->valeur=p->valeur; // on donne la valeur de l'element en p  au duplicat pi
        pi->prec=ppi; // on rattache pi a`son precedent ppi dans li
        ppi->suiv=pi; // on rattache ppi a`son suivant pi dans li
    }
    
    pi->suiv = li;  // on rattache le dernier element traite au premier dans li (circularite')
    li->prec=pi;    // on attache li (par le lien precedent) a`ce dernier element
    return li;
    //
}

listeD inverserListeNDPrim (listeD l){
    /* renvoie une liste li inverse de la liste l (sans detruire l) */
    // Version qui utilise les primitives de listesDoublementChainees.h
    listeD li=creerListe();
    cellule *p;
    p=l;
    while (!fin(p,l)) {
        li=ajouterEnPosition(p->valeur, li, li); // en te^te de li
        p=successeur(p,l);
    }
    return li;
}


/*
 4
 1 2 3 4
 liste 1 2 3 4
 liste 4 3 2 1
 liste 1 2 3 4
 liste 1 2 3 4
 Program ended with exit code: 0
*/